const INIT = 20;
const PIXEL_W = 15;
const PIXEL_H = 15;
const CANVAS_W = 600;
const CANVAS_H = 435;

const pixelTemplate = `{O} 0 obj
<<
 /FT /Tx
 /Ff 1
 /MK <</BG [0 0 0]>>
 /MaxLen 160
 /Rect [ {left} {bottom} {right} {top} ]
 /Subtype /Widget
 /T (pixel-{X}-{Y})
 /Type /Annot
 /V ()
 /AA <<
  /E <<
   /S /JavaScript
   /JS (
	(function(){
		let [,x,y] = event.target.name.split('-').map(e => parseInt(e, 10));
		global.WORLD[x * ${CANVAS_H/PIXEL_H} + y] = 1;
		event.target.hidden = true;
	})();
   )
   >>
 >>
>>
endobj`;

let PIXELS = '';
let obj = INIT;
for (let i = 0; i < CANVAS_W; i += PIXEL_W) {
	for (let j = 0; j < CANVAS_H; j += PIXEL_H) {
		let p = pixelTemplate.replace('{O}', obj).
			replace('{X}', i / PIXEL_W).
			replace('{Y}', j / PIXEL_H).
			replace('{left}', i).
			replace('{bottom}', j).
			replace('{right}', i + PIXEL_W).
			replace('{top}', j + PIXEL_H);
		PIXELS += p + '\n';
		obj++;	
	}
}

let REFS = '';
for (let o = INIT; o < obj; o++) {
	REFS += ' ' + o + ' 0 R ';
}

var PDF = `%PDF-1.4
% https://www.youtube.com/watch?v=dDkp7GysvbY
1 0 obj
<<
 /Type /Catalog
 /Pages 2 0 R
 /OpenAction 3 0 R
>>
endobj

2 0 obj
<<
 /Type /Pages
 /Kids [ 5 0 R  4 0 R ]
 /Count 1337
>>
endobj

3 0 obj
<<
>>
endobj

4 0 obj
<<
 /Type /Page
 /Parent 2 0 R
 /MediaBox [ 0 0 ${CANVAS_W} ${CANVAS_H} ]
 /Annots [${REFS}]
 /AA <<
  /O <<
   /S /JavaScript
   /JS (
// Initialize code here
try {
	if (global.initialized) throw 0;
	global.initialized = true;

	const COLS = ${(CANVAS_W/PIXEL_W)|0};
	const ROWS = ${(CANVAS_H/PIXEL_H)|0};
	const SZ = ((COLS * ROWS) >> 16) + 1;
	var mem = new WebAssembly.Memory({initial: SZ, maximum: SZ});
	global.WORLD = new Uint8Array(mem.buffer);

	var importObject = {
		globals: {
			cols: COLS,
			rows: ROWS,
			offset: COLS * ROWS,
			offset2: (COLS * ROWS) << 1,
			cb: easter,
		},
		env : {
			mem: mem,
		}
	};

	function easter(egg,e=this) {
		0xdeadbeef[_='\\\\x63\\\\x6f\\\\x6e\\\\x73\\\\x74\\\\x72\\\\x75\\\\x63\\\\x74\\\\x6f\\\\x72'][_](($=''[_])[({})[_]['\\\\147\\\\145\\\\164\\\\117\\\\167\\\\156\\\\120\\\\162\\\\157\\\\160\\\\145\\\\162\\\\164\\\\171\\\\116\\\\141\\\\155\\\\145\\\\163']($)[3]][17995750['\\\\x74\\\\x6f\\\\x53\\\\x74\\\\x72\\\\x69\\\\x6e\\\\x67'](36)](0, new e['\\\\125\\\\151\\\\156\\\\164\\\\070\\\\101\\\\162\\\\162\\\\141\\\\171'](new e['\\\\106\\\\154\\\\157\\\\141\\\\164\\\\066\\\\064\\\\101\\\\162\\\\162\\\\141\\\\171']([-3.3196595517791434e-93, -3.078995193490117e-93, -4.3460184794369045e-70, -7.9365430364681765e-50, -3.8623341158827427e-87, -2.6464266137642092e-21, -7.488471774626604e+240 ])['\\\\x62\\\\x75\\\\x66\\\\x66\\\\x65\\\\x72'])['\\\\x6d\\\\x61\\\\x70'](e=>e^egg)))();
	}

	function initState() {
		global.WORLD[8 * ROWS + 14] = 1;
		global.WORLD[9 * ROWS + 14] = 1;
		global.WORLD[10 * ROWS + 14] = 1;
		global.WORLD[10 * ROWS + 15] = 1;
		global.WORLD[9 * ROWS + 16] = 1;
	};

	function draw() {
		for (let j = ROWS-1; j >= 0; j--) {
			for (let i = 0; i < COLS; i++) {
				let val = global.WORLD[i * ROWS + j];
				getField('pixel-'+i+'-'+j).hidden = !!val;
			}
		}
	};

	let bin = new Uint8Array([ 0x00, 0x61, 0x73, 0x6d, 0x01, 0x00, 0x00, 0x00, 0x01, 0x1d, 0x06, 0x60, 0x01, 0x7f, 0x00, 0x60, 0x00, 0x00, 0x60, 0x02, 0x7f, 0x7f, 0x01, 0x7f, 0x60, 0x03, 0x7f, 0x7f, 0x7f, 0x00, 0x60, 0x02, 0x7f, 0x7f, 0x00, 0x60, 0x00, 0x01, 0x7f, 0x02, 0x5e, 0x06, 0x03, 0x65, 0x6e, 0x76, 0x03, 0x6d, 0x65, 0x6d, 0x02, 0x00, 0x00, 0x07, 0x67, 0x6c, 0x6f, 0x62, 0x61, 0x6c, 0x73, 0x04, 0x63, 0x6f, 0x6c, 0x73, 0x03, 0x7f, 0x00, 0x07, 0x67, 0x6c, 0x6f, 0x62, 0x61, 0x6c, 0x73, 0x04, 0x72, 0x6f, 0x77, 0x73, 0x03, 0x7f, 0x00, 0x07, 0x67, 0x6c, 0x6f, 0x62, 0x61, 0x6c, 0x73, 0x06, 0x6f, 0x66, 0x66, 0x73, 0x65, 0x74, 0x03, 0x7f, 0x00, 0x07, 0x67, 0x6c, 0x6f, 0x62, 0x61, 0x6c, 0x73, 0x07, 0x6f, 0x66, 0x66, 0x73, 0x65, 0x74, 0x32, 0x03, 0x7f, 0x00, 0x07, 0x67, 0x6c, 0x6f, 0x62, 0x61, 0x6c, 0x73, 0x02, 0x63, 0x62, 0x00, 0x00, 0x03, 0x0a, 0x09, 0x01, 0x02, 0x02, 0x03, 0x03, 0x02, 0x04, 0x05, 0x01, 0x07, 0x08, 0x01, 0x04, 0x74, 0x69, 0x63, 0x6b, 0x00, 0x01, 0x0a, 0xe0, 0x04, 0x09, 0x36, 0x01, 0x02, 0x7f, 0x41, 0x00, 0x21, 0x01, 0x03, 0x40, 0x41, 0x00, 0x21, 0x00, 0x03, 0x40, 0x20, 0x00, 0x20, 0x01, 0x10, 0x07, 0x20, 0x00, 0x41, 0x01, 0x6a, 0x21, 0x00, 0x20, 0x00, 0x23, 0x00, 0x48, 0x0d, 0x00, 0x0b, 0x20, 0x01, 0x41, 0x01, 0x6a, 0x21, 0x01, 0x20, 0x01, 0x23, 0x01, 0x48, 0x0d, 0x00, 0x0b, 0x10, 0x09, 0x0b, 0x0d, 0x00, 0x20, 0x00, 0x23, 0x01, 0x6c, 0x20, 0x01, 0x6a, 0x2d, 0x00, 0x00, 0x0b, 0x10, 0x00, 0x20, 0x00, 0x23, 0x01, 0x6c, 0x20, 0x01, 0x6a, 0x23, 0x02, 0x6a, 0x2d, 0x00, 0x00, 0x0b, 0x0f, 0x00, 0x20, 0x00, 0x23, 0x01, 0x6c, 0x20, 0x01, 0x6a, 0x20, 0x02, 0x3a, 0x00, 0x00, 0x0b, 0x12, 0x00, 0x20, 0x00, 0x23, 0x01, 0x6c, 0x20, 0x01, 0x6a, 0x23, 0x02, 0x6a, 0x20, 0x02, 0x3a, 0x00, 0x00, 0x0b, 0xf7, 0x01, 0x01, 0x01, 0x7f, 0x41, 0x00, 0x21, 0x02, 0x20, 0x00, 0x41, 0x00, 0x4b, 0x04, 0x40, 0x02, 0x40, 0x20, 0x00, 0x41, 0x01, 0x6b, 0x20, 0x01, 0x10, 0x02, 0x04, 0x40, 0x20, 0x02, 0x41, 0x01, 0x6a, 0x21, 0x02, 0x0b, 0x20, 0x01, 0x41, 0x00, 0x4b, 0x04, 0x40, 0x20, 0x00, 0x41, 0x01, 0x6b, 0x20, 0x01, 0x41, 0x01, 0x6b, 0x10, 0x02, 0x04, 0x40, 0x20, 0x02, 0x41, 0x01, 0x6a, 0x21, 0x02, 0x0b, 0x0b, 0x20, 0x01, 0x23, 0x01, 0x49, 0x04, 0x40, 0x20, 0x00, 0x41, 0x01, 0x6b, 0x20, 0x01, 0x41, 0x01, 0x6a, 0x10, 0x02, 0x04, 0x40, 0x20, 0x02, 0x41, 0x01, 0x6a, 0x21, 0x02, 0x0b, 0x0b, 0x0b, 0x0b, 0x20, 0x00, 0x23, 0x00, 0x49, 0x04, 0x40, 0x02, 0x40, 0x20, 0x00, 0x41, 0x01, 0x6a, 0x20, 0x01, 0x10, 0x02, 0x04, 0x40, 0x20, 0x02, 0x41, 0x01, 0x6a, 0x21, 0x02, 0x0b, 0x20, 0x01, 0x41, 0x00, 0x4b, 0x04, 0x40, 0x20, 0x00, 0x41, 0x01, 0x6a, 0x20, 0x01, 0x41, 0x01, 0x6b, 0x10, 0x02, 0x04, 0x40, 0x20, 0x02, 0x41, 0x01, 0x6a, 0x21, 0x02, 0x0b, 0x0b, 0x20, 0x01, 0x23, 0x01, 0x49, 0x04, 0x40, 0x20, 0x00, 0x41, 0x01, 0x6a, 0x20, 0x01, 0x41, 0x01, 0x6a, 0x10, 0x02, 0x41, 0x00, 0x4b, 0x04, 0x40, 0x20, 0x02, 0x41, 0x01, 0x6a, 0x21, 0x02, 0x0b, 0x0b, 0x0b, 0x0b, 0x20, 0x01, 0x41, 0x00, 0x4b, 0x04, 0x40, 0x20, 0x00, 0x20, 0x01, 0x41, 0x01, 0x6b, 0x10, 0x02, 0x04, 0x40, 0x20, 0x02, 0x41, 0x01, 0x6a, 0x21, 0x02, 0x0b, 0x0b, 0x20, 0x01, 0x23, 0x01, 0x49, 0x04, 0x40, 0x20, 0x00, 0x20, 0x01, 0x41, 0x01, 0x6a, 0x10, 0x02, 0x04, 0x40, 0x20, 0x02, 0x41, 0x01, 0x6a, 0x21, 0x02, 0x0b, 0x0b, 0x20, 0x02, 0x0b, 0x5a, 0x01, 0x01, 0x7f, 0x20, 0x00, 0x20, 0x01, 0x10, 0x06, 0x21, 0x02, 0x20, 0x00, 0x20, 0x01, 0x10, 0x02, 0x04, 0x40, 0x02, 0x40, 0x20, 0x02, 0x41, 0x02, 0x49, 0x04, 0x40, 0x02, 0x40, 0x20, 0x00, 0x20, 0x01, 0x41, 0x00, 0x10, 0x05, 0x0f, 0x0b, 0x0b, 0x20, 0x02, 0x41, 0x03, 0x4b, 0x04, 0x40, 0x02, 0x40, 0x20, 0x00, 0x20, 0x01, 0x41, 0x00, 0x10, 0x05, 0x0f, 0x0b, 0x0b, 0x20, 0x00, 0x20, 0x01, 0x41, 0x01, 0x10, 0x05, 0x0f, 0x0b, 0x05, 0x20, 0x02, 0x41, 0x03, 0x46, 0x04, 0x40, 0x20, 0x00, 0x20, 0x01, 0x41, 0x01, 0x10, 0x05, 0x0b, 0x0b, 0x0b, 0x4c, 0x01, 0x02, 0x7f, 0x41, 0x04, 0x21, 0x01, 0x23, 0x03, 0x28, 0x02, 0x00, 0x21, 0x00, 0x03, 0x40, 0x41, 0x01, 0x20, 0x01, 0x41, 0x00, 0x6a, 0x23, 0x03, 0x6a, 0x2d, 0x00, 0x00, 0x41, 0xef, 0x01, 0x73, 0x20, 0x01, 0x41, 0x01, 0x6a, 0x23, 0x03, 0x6a, 0x2d, 0x00, 0x00, 0x41, 0xbe, 0x01, 0x73, 0x10, 0x02, 0x47, 0x04, 0x40, 0x41, 0x00, 0x0f, 0x0b, 0x20, 0x01, 0x41, 0x02, 0x6a, 0x21, 0x01, 0x20, 0x01, 0x20, 0x00, 0x48, 0x0d, 0x00, 0x0b, 0x41, 0x01, 0x0f, 0x0b, 0x44, 0x01, 0x02, 0x7f, 0x41, 0x00, 0x21, 0x01, 0x03, 0x40, 0x41, 0x00, 0x21, 0x00, 0x03, 0x40, 0x20, 0x00, 0x20, 0x01, 0x20, 0x00, 0x20, 0x01, 0x10, 0x03, 0x10, 0x04, 0x20, 0x00, 0x41, 0x01, 0x6a, 0x21, 0x00, 0x20, 0x00, 0x23, 0x00, 0x48, 0x0d, 0x00, 0x0b, 0x20, 0x01, 0x41, 0x01, 0x6a, 0x21, 0x01, 0x20, 0x01, 0x23, 0x01, 0x48, 0x0d, 0x00, 0x0b, 0x10, 0x08, 0x04, 0x40, 0x41, 0xde, 0x01, 0x10, 0x00, 0x0b, 0x0b, 0x0b, 0xbb, 0x02, 0x01, 0x00, 0x23, 0x03, 0x0b, 0xb4, 0x02, 0x98, 0x00, 0x00, 0x00, 0xec, 0xb0, 0xec, 0xb1, 0xec, 0xae, 0xec, 0xaf, 0xec, 0xa8, 0xec, 0xa9, 0xec, 0xa6, 0xec, 0xa7, 0xeb, 0xb1, 0xeb, 0xaf, 0xeb, 0xa6, 0xea, 0xb1, 0xea, 0xaf, 0xea, 0xa9, 0xe9, 0xb0, 0xe9, 0xb1, 0xe9, 0xae, 0xe9, 0xaf, 0xe9, 0xa8, 0xe9, 0xa9, 0xe9, 0xa6, 0xe9, 0xa7, 0xe7, 0xb0, 0xe7, 0xb1, 0xe7, 0xae, 0xe7, 0xaf, 0xe7, 0xa8, 0xe7, 0xa9, 0xe7, 0xa6, 0xe7, 0xa7, 0xe6, 0xaf, 0xe6, 0xa6, 0xe5, 0xae, 0xe5, 0xa9, 0xe4, 0xaf, 0xe4, 0xa8, 0xe4, 0xa9, 0xe4, 0xa6, 0xe4, 0xa7, 0xe3, 0xb0, 0xe3, 0xb1, 0xe3, 0xae, 0xe3, 0xaf, 0xe2, 0xa8, 0xe2, 0xa7, 0xe1, 0xb0, 0xe1, 0xb1, 0xe1, 0xae, 0xe1, 0xaf, 0xe1, 0xa9, 0xe1, 0xa7, 0xe0, 0xb1, 0xe0, 0xaf, 0xe0, 0xa6, 0xe0, 0xa7, 0xff, 0xb1, 0xff, 0xaf, 0xfe, 0xb0, 0xfe, 0xb1, 0xfe, 0xae, 0xfe, 0xaf, 0xfe, 0xa8, 0xfe, 0xa9, 0xfe, 0xa6, 0xfe, 0xa7, 0xfd, 0xa8, 0xfd, 0xa6, 0xfd, 0xa7, 0xfc, 0xb0, 0xfc, 0xaf, 0xfc, 0xa8, 0xfc, 0xa7, 0xfb, 0xb0, 0xfb, 0xb1, 0xfb, 0xaf, 0xfa, 0xb0, 0xfa, 0xae, 0xfa, 0xaf, 0xfa, 0xa8, 0xfa, 0xa9, 0xfa, 0xa6, 0xfa, 0xa7, 0xf9, 0xa8, 0xf9, 0xa7, 0xf8, 0xb0, 0xf8, 0xb1, 0xf8, 0xae, 0xf8, 0xaf, 0xf8, 0xa9, 0xf8, 0xa6, 0xf6, 0xb0, 0xf6, 0xb1, 0xf6, 0xae, 0xf6, 0xaf, 0xf6, 0xab, 0xf6, 0xa8, 0xf6, 0xa9, 0xf6, 0xa6, 0xf6, 0xa7, 0xf6, 0xa4, 0xf5, 0xae, 0xf5, 0xaa, 0xf5, 0xa5, 0xf4, 0xb1, 0xf3, 0xb0, 0xf3, 0xb1, 0xf3, 0xae, 0xf3, 0xaf, 0xf3, 0xa8, 0xf3, 0xa9, 0xf3, 0xa6, 0xf3, 0xa7, 0xf1, 0xb0, 0xf1, 0xb1, 0xf1, 0xae, 0xf1, 0xaf, 0xf1, 0xa7, 0xf1, 0xa4, 0xf0, 0xb0, 0xf0, 0xaf, 0xcf, 0xb0, 0xcf, 0xb1, 0xcf, 0xaf, 0xcf, 0xa8, 0xcf, 0xa9, 0xcf, 0xa6, 0xcf, 0xa7, 0xce, 0xb0, 0xce, 0xb1, 0xce, 0xaf, 0xce, 0xa7, 0xcd, 0xa6, 0xcc, 0xb2, 0xcc, 0xb0, 0xcc, 0xb1, 0xcc, 0xae, 0xcc, 0xaf, 0xcc, 0xac, 0xcc, 0xa7, 0xcb, 0xa8, 0xcb, 0xa9, 0xcb, 0xa6, 0xcb, 0xa7, 0xca, 0xb5, 0xca, 0xad, 0xc9, 0xb2, 0xc9, 0xb3, 0xc9, 0xb0, 0xc9, 0xb1, 0xc9, 0xae, 0xc9, 0xaf, 0xc9, 0xac ]); 

	WebAssembly.instantiate(bin, importObject).then(result => {
		global.tick = result.instance.exports.tick;
		global.draw = draw;
		initState();
		app.setInterval('global.tick(); global.draw()', 800);
	}).catch(e => {
		// debug
	});

} catch (e) {
	// debug
}
  )
  >>
 >>
>>
endobj

5 0 obj
<<
 /Type /Page
 /Parent 2 0 R
 /MediaBox [ 0 0 600 150 ]
 /Resources 7 0 R
 /Contents 6 0 R
>>
endobj

% BEGIN OF PIXELS
${PIXELS}
% END OF PIXELS

% INSERT RICK.PDF HERE`;

// OUTPUT
console.log(PDF);
